$(document).on('change', '.complex_relation_section input:visible, .complex_relation_section select:visible', function() {
  var is_required = false;

  var $field_wrapper = $(this).closest('.complex_relation_section');
  var $child_elements = $field_wrapper.find('input:visible, select:visible');

  $child_elements.each(function(index, child){ 
    if ($(child).val().length > 0){
      is_required = true
    }
  });

  is_required ? $child_elements.prop('required', true) : $child_elements.prop('required', false) 
});


$(document).on('keyup', '.folder-name', function() {
  var folder_name_pattern = /^[a-zA-Z0-9][a-zA-Z0-9\-\. ]*$/;
  folder_name = $(this).val();
  path = $(this).data('validation-path');

  if (folder_name.length >= 3){
    if (folder_name_pattern.test(folder_name)) {
      $.ajax({
        url : path,
        type : 'GET',
        data : {
            'folder_name' :folder_name
        },
        dataType:'json',
        success : function(response) {              
          if(response.data_exist){
            $('.folder_name_error').show().html('Folder name already taken').css('color', '#ff3333');
          }else{
            $('.folder_name_error').hide();
          }
        },
        error : function(request,error)
        {
          alert("Request: "+JSON.stringify(request));
        }
      });
    } else {
      error_massage = 'Folder name not valid. Folder name should be a combination of only lowercase letters, numbers, hyphen, dot, and space. The name and should start with a letter or number'
      $('.folder_name_error').show().html(error_massage).css('color', '#ff3333');
    }
  }
});